package icfp.contest;

import java.awt.*;
import java.util.*;

/**
 * Insert the type's description here.
 * Creation date: (8/31/02 10:52:12 AM)
 * @author: Pablo J. Pedemonte
 */
public final class PlayerConfig {
	public String uid;
	public int capacity;
	public int money;
	public Point pos;

	/** Map packet to uid */
	public Hashtable packages;
/**
 * PlayerConfig constructor comment.
 */
public PlayerConfig() {
	super();
	pos = new Point(0,0);
	packages = new Hashtable();
}
/**
 * Insert the method's description here.
 * Creation date: (8/31/02 6:04:04 PM)
 * @param p icfp.contest.Package
 */
public void addPackage(Package p) {
	this.capacity -= p.weight;
	packages.put(p.uid, p);
}
/**
 * Insert the method's description here.
 * Creation date: (8/31/02 11:47:49 AM)
 * @param o java.lang.Object
 */
public boolean equals(Object o) {
	if (o instanceof PlayerConfig) {
		return uid.equals(((PlayerConfig)o).uid);
	}

	return false;
}
/**
 * Insert the method's description here.
 * Creation date: (8/31/02 12:08:24 PM)
 * @return icfp.contest.PlayerConfig
 * @param s java.lang.String
 */
public final static PlayerConfig parseFrom(String s) {
	StringTokenizer t = new StringTokenizer(s, " \t");
	PlayerConfig config = new PlayerConfig();
	config.uid      = t.nextToken();
	config.capacity = Integer.parseInt(t.nextToken());
	config.money    = Integer.parseInt(t.nextToken());
	return config;
}
/**
 * Insert the method's description here.
 * Creation date: (8/31/02 6:04:04 PM)
 * @param p icfp.contest.Package
 */
public Package removePackage(String uid) {
	Package p = (Package)packages.remove(uid);
	this.capacity += p.weight;
	return p;
}
/**
 * Insert the method's description here.
 * Creation date: (8/31/02 11:45:29 AM)
 * @return java.lang.String
 */
public String toString() {
	StringBuffer b = new StringBuffer();
	b.append("C(#");
	b.append(uid);
	b.append(' ');
	b.append(pos);
	b.append(' ');
	b.append(capacity);
	b.append(' ');
	b.append(money);
	b.append(' ');
	b.append(packages);
	b.append(')');
	return b.toString();
}
}
